<?php

require_once '_db.php';
require_once '_common.php';
require_once '_uit_head.php';

$menu_type_x = substr($_SERVER["QUERY_STRING"], 5);

if ($menu_type_x == "edit_attributes" || $menu_type_x == "new_attribute") {
  $bundle_array = get_attribute_groups();
  if (empty($bundle_array)) {
    $menu_type_x = "new_attribute_group";
    if (session_status() !== PHP_SESSION_ACTIVE) {
      session_start();
    }
    $_SESSION["message"] = 'At least one attribute group must be '
                         . 'defined before working with attributes';
    $_SESSION["message_type"] = 'DANGER';
  }
}

function renderForm($menu_type)
{

  display_header('Stanford Directory Access Request');

  if ($menu_type == "edit_attributes" || $menu_type == "edit_attribute_groups") {
    print '<script src="javascript/bootstrap/js/bootstrap.min.js"></script>';
  }

  if (isset($_SESSION["message"])) {
    $message = $_SESSION["message"];
    print '<div class="alert alert-danger"><strong>' . $message . '</strong></div>';
    unset($_SESSION["message"]);
  }

  nav("admin_menu");

  print <<<'EOS'
<script type="text/javascript"
        src="https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js"></script>
<script type="text/javascript"
        src="https://cdn.datatables.net/fixedcolumns/3.2.4/js/dataTables.fixedColumns.min.js"></script>
<script type="text/javascript"
        src="https://cdn.datatables.net/responsive/2.2.1/js/dataTables.responsive.min.js"></script>
<link type="text/css" rel="stylesheet"
      href="https://cdn.datatables.net/1.10.16/css/jquery.dataTables.min.css"/>
<link type="text/css" rel="stylesheet"
      href="https://cdn.datatables.net/responsive/2.2.1/css/responsive.bootstrap.min.css"/>

<style>
  .dataTables_filter { text-align: right !important; }
  .dataTables_length select { width: 80px; }
  div.dataTables_length label { width: 200px; float: left;
  			        text-align: left; padding-bottom: 10px; }
  div.dataTables_info { padding-top: 10px; }
  div.dataTables_paginate { float: right; margin: 0; }
  div.content-wrapper.content-wrapper { width: 100%; }
  table.dataTable tbody td { vertical-align: top !important; }
  div#content.mc-content.span8 { width: 86%; }
  div.modal-header { width: 886px; }
  div.modal-body { width: 850px; }
  div.modal-footer { width: 886px; }
  div.modal-content { width: 890px; }
}
</style>
<script>

var func = "";

$(document).ready(function(){
  $('#submit_button1').on('click', function(e) {
    request_details($("#request_id").val());
  });

  $('#submit_button2').on('click', function(e) {
    func = "move_requests";
    confirm_archive($("#request_id").val());
  });

  $('#submit_button3').on('click', function(e) {
    func = "purge_requests";
    confirm_purge($("#request_id").val());
  });

  $('#submit_button4').on('click', function(e) {
    func = "new_attribute";
    new_attribute($("#attribute_name").val(), $("#attribute_group_name").val());
  });

  $('#submit_button5').on('click', function(e) {
    func = "new_attribute_group";
    new_attribute_group($("#attribute_group_name").val());
  });

  $('#yes_button').on('click', function(e) {
    $("form").submit();
  });

  $('#attributes').DataTable({
    scrollX: true,
    pagingType: "full_numbers",
    pageLength: 50,
    columnDefs: [ { width: 40, targets: 0 } ],
    order: [ [2,"asc"], [1,"asc"] ]
  });

});

function confirm_archive(id) {
  $('.modal-body').html('Are you sure you want to move Request IDs to archive &lt;= Request ID ' + id + '?');
  jQuery('#detailModal').modal();
}

function confirm_purge(id) {
  $('.modal-body').html('Are you sure you want to purge Request IDs in archive &lt;= Request ID ' + id + '?');
  jQuery('#detailModal').modal();
}

function remove_attribute(attribute_name, attribute_group_name) {
  func = "remove_attribute";
  $('input[name="attribute_name"]').val(attribute_name);
  $('input[name="attribute_group_name"]').val(attribute_group_name);
  $('.modal-body').html('Are you sure you want to delete attribute '
                        + attribute_name + ' from group ' + attribute_group_name + '?');
  jQuery('#detailModal').modal();
}

function remove_attribute_group(attribute_group_name) {
  func = "remove_attribute_group";
  $('input[name="attribute_group_name"]').val(attribute_group_name);
  jQuery('.modal-body').html('Are you sure you want to delete attribute group '
                             + attribute_group_name + '?');
  jQuery('#detailModal').modal();
}

function new_attribute(attribute_name, attribute_group_name) {
  //
  // if(attribute_name.match(/^[a-zA-Z0-9, ]+$/i) == null) {
  //   alert("Attribute Name can only contain alpha-numeric characters");
  //   return false;
  // } else {
  //
  func = "new_attribute";
  $('input[name="attribute_name"]').val(attribute_name);
  $('input[name="attribute_group_name"]').val(attribute_group_name);
  $("form").submit();
  //
  // }
  //
}

function new_attribute_group(attribute_group_name) {
  if(attribute_group_name.match(/^[a-zA-Z][a-zA-Z0-9_]*$/i) == null) {
    alert("Attribute Group Name can only contain alpha-numeric characters and must start with a letter");
    return false;
  } else {
    func = "new_attribute_group";
    $('input[name="attribute_group_name"]').val(attribute_group_name);
    $("form").submit();
  }
}

function request_details2(id) {
  $.ajax({
    type: 'post',
    url: '_dataowner_list_details.php',
    data: 'param=' + id,
    success: function(d) {
      $('.modal-body').html(d);
      $('.modal-body').scrollTop(0);
      $('.modal-title').html("Approval Details for Request " + id);
    }
  });
  $('#detailModal').modal();
}

function request_details(id) {
  $.ajax({
    type: 'post',
    url: '_admin_menu_xx.php',
    data: {
      'function_selector': 'check_record',
      'request_id': id
    },
    success: function(d) {
      if (d == "FALSE") {
        d = 'There is no record for Request ID ' + id;
        $('#yes_button').hide();
      } else {
        $('#yes_button').show();
      }
      $('.modal-body').html(d);
    }
  });
  jQuery('#detailModal').modal();
}
</script>
EOS;

  print <<<'EOT'
    <div id="detailModal" class="modal fade" role="dialog"  style="width:940px; margin-left: -500px;">
     <div class="modal-dialog" style="width:940px;">
        <div class="modal-content">
          <div class="modal-header">
           <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <h3 class="modal-title" style="color: #8c1515">Confirmation</h3>
          </div>
          <div class="modal-body">
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" id="yes_button" data-dismiss="modal">Yes</button>
            <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
EOT;

  switch ($menu_type) {
    case "delete_request":
      print <<<'EOP'
        <form id="delete_request" name="delete_request" method="post" action="_admin_menu_xx.php" role="form">
        <input type="hidden" name="function_selector" value="delete_request" required>
        <table border=1 class="main">
          <tr>
            <td style="width: 300px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
              <b>Delete Request ID</b>
            </td>
            <td>
              <input type="text" name="request_id" id="request_id"
                     class="inputfield" placeholder="Enter Request ID"
                     style="height:30px;" required="true"/>
            </td>
          </tr>
        </table>
        <button type="button" id="submit_button1" class="btn btn-primary">Submit</button>
        </form>
EOP;
      break;
    case "move_requests":
      print <<<'EOK'
        <form id="move_requests" name="move_requests" method="post" action="_admin_menu_xx.php" role="form">
        <input type="hidden" name="function_selector" value="move_requests">
        <table border=1 class="main">
          <tr>
            <td style="width: 300px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
              <b>Move Request IDs to archive &lt;= </b>
            </td>
            <td>
              <input type="text" name="request_id" id="request_id" class="inputfield"
            placeholder="Enter Request ID" style="height:30px;" required="true"/>
            </td>
          </tr>
        </table>
        <button type="button" id="submit_button2" class="btn btn-primary">Submit</button>
        </form>
EOK;
      break;
    case "purge_requests":
      print <<<'EOJ'
        <form id="move_requests" name="purge_requests" method="post" action="_admin_menu_xx.php" role="form">
        <input type="hidden" name="function_selector" value="purge_requests">
        <table border=1 class="main">
          <tr>
            <td style="width: 300px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
              <b>Purge Request IDs in archive &lt;= </b>
            </td>
            <td>
              <input type="text" name="request_id" id="request_id" class="inputfield"
                     placeholder="Enter Request ID" style="height:30px;" required="true"/>
            </td>
          </tr>
        </table>
        <button type="button" id="submit_button3" class="btn btn-primary">Submit</button>
        </form>
EOJ;
      break;

    case "edit_attributes":
      print <<<'EOR'
        <form id="remove_attribute" name="remove_attribute" method="post" action="_admin_menu_xx.php" role="form">
          <input type="hidden" name="function_selector" value="remove_attribute">
          <input type="hidden" name="attribute_name" id="attribute_name" value="">
          <input type="hidden" name="attribute_group_name" id="attribute_group_name" value="">
        </form>
EOR;
      //
      // bootstrap datatables
      //
      print <<<'EOH'
        <table id="attributes" class="table table-striped table-bordered compact"
	       cellspacing="0" width="100%">
          <thead>
            <tr>
              <th>Remove Attribute</th>
              <th>Attribute Group</th>
              <th>Created By</th>
              <th>Creation Date</th>
            </tr>
          </thead>
          <tbody>
EOH;

      $attrs = show_custom_attributes();
      foreach ($attrs as $values) {
        print '<tr>';
        print '<td><a href="javascript:remove_attribute(\'' . $values["attribute_name"]
              . '\',\'' . $values["group_name"] . '\');"> ' . $values["attribute_name"]
              . '</a></td>';
        print '<td width="120px;">' . $values["group_name"] . '</td>';
        print '<td width="120px;">' . $values["created_by_uid"] . '</td>';
        print '<td width="120px;">' . $values["created_date"] . '</td>';
        print '</tr>';
      }
      print '
          </tbody>
        </table>';
      break;

    case "edit_attribute_groups":
      print '
        <form id="remove_attribute_group" name="remove_attribute_group" method="post" action="_admin_menu_xx.php" role="form">
          <input type="hidden" name="function_selector" value="remove_attribute_group">
          <input type="hidden" name="attribute_group_name" id="attribute_group_name" value="">
        </form>';
      //
      // bootstrap datatables
      //
      print <<<EOB
        <table id="attributes" class="table table-striped table-bordered compact" cellspacing="0" width="100%">
          <thead>
            <tr>
              <th>Remove Attribute Group</th>
              <th>Created By</th>
              <th>Creation Date</th>
            </tr>
          </thead>
          <tbody>
EOB;

      $attrs = show_attribute_groups();
      foreach ($attrs as $values) {
        print '<tr>';
	if ($values["group_name"] != 'All') {
          print '<td><a href="javascript:remove_attribute_group(\'' . $values["group_name"] . '\');"> ' . $values["group_name"] . '</a></td>';
        } else {
          print '<td>' . $values["group_name"] . '</td>';
	}
        print '<td width="120px;">' . $values["created_by_uid"] . '</td>';
        print '<td width="120px;">' . $values["created_date"] . '</td>';
        print '</tr>';
      }
      print '
          </tbody>
        </table>';
      break;

    case "new_attribute":
      print <<<'EOC'
        <form id="new_attribute" name="new_attribute" method="post" action="_admin_menu_xx.php" role="form">
        <input type="hidden" name="function_selector" value="new_attribute">
        <table border=1 class="main">
          <tr>
            <td style="width: 400px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
              <b>Select Attribute Group</b>
            </td>
            <td>
              <select class="selectpicker" data-size="auto" id="attribute_group_name" name="attribute_group_name">';
              print '<option disabled selected required>Nothing selected</option>
EOC;
              $bundle_array = get_attribute_groups();
              foreach ($bundle_array as $value) {
                print '<option>' . $value['group_name'] . '</option>';
              }
              print <<<'EOR'
              </select>
            </td>
          </tr>
          <tr>
            <td style="width: 400px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
              <b>Enter Attribute Name</b>
            </td>
            <td>
              <textarea class="form-group" id="attribute_name"
                        name="attribute_name" rows="6"
                        style="width:98%; font-family: "Helvetica Neue,Helvetica,Arial,sans-serif;"
                        placeholder="Enter comma seperated list of attributes"></textarea>
            </td>
          </tr>
        </table>
        <button type="button" id="submit_button4" class="btn btn-primary">Submit</button>
        </form>
EOR;
      break;

    case "new_attribute_group":
      print <<<'EOS'
        <form id="new_attribute_group" name="new_attribute_group" method="post" action="_admin_menu_xx.php" role="form">
        <input type="hidden" name="function_selector" value="new_attribute_group">
        <table border=1 class="main">
          <tr>
            <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
              <b>Enter Attribute Group</b>
            </td>
            <td>
              <input type="text" name="attribute_group_name" id="attribute_group_name"
                     class="inputfield" placeholder="Enter Attribute Group"
                     style="height:30px;" required="true"/></td>
          </tr>
        </table>
        <button type="button" id="submit_button5" class="btn btn-primary">Submit</button>
        </form>
EOS;
      break;

    case "report1":
      print <<<'EOT'
        <style>
          th.rotate { height: 200px; white-space: nowrap; }
          th.rotate > div { transform: translate(10px, 0px) rotate(315deg); width: 20px; }
          th.rotate > div > span { border-bottom: 1px solid #ccc; padding: -5px 10px; }
          table, th, td { border: 1px solid #ccc; padding: 0px; border-spacing: 0px; }
        </style>
        <table>
EOT;


      // Print the header row (all the approvers).
      print '<tr><th valign="bottom">Request ID</th>';
      $r            = get_reviewers();
      $approvers    = array();
      foreach ($r as $value) {
        $full_name = $value["full_name"];
        array_push($approvers, $full_name);
        print '<th class="rotate"> <div><span>' . $full_name . '</span></div></th>';
      }
      print "</tr>\n";

      // Print each request.
      $x = get_old_request_report();

      // $x has one row for each approval status for each request id. The next
      // step creates a mapping taking request id to approval statuses.
      $rid_to_statuses = array();
      foreach ($x as $value) {
        $request_id = $value["request_id"];
        $approver   = $value["approver"];
        $status     = $value["status"];

        // We only consider real approvers.
        if (in_array($approver, $approvers)) {
          if (array_key_exists($request_id, $rid_to_statuses)) {
            $statuses                     = $rid_to_statuses[$request_id];
            $statuses[$approver]          = $status;
            $rid_to_statuses[$request_id] = $statuses;
          } else {
            $statuses                   = array();
            $statuses[$approver]        = $status;
            $rid_to_statuses[$request_id] = $statuses;
          }
        }

      }

      // We now can loop over $rid_to_statuses
      foreach ($rid_to_statuses as $request_id => $statuses) {

        // The first column is the request id linked to its details.
        print '<tr><td style="width: 110px;"><a href="javascript:request_details2(\''
             . $request_id . '\');"> ' . $request_id . '</a></td>';

        // Loop over the $approvers
        foreach ($approvers as $approver) {
          $status = $statuses[$approver];
          switch ($status) {
            case 'APPROVED':
                print '<td title="approved" style="width: 50px; background-color: #03c420"></td>';
                break;
            case 'PENDING':
                print '<td title="pending" style="width: 50px; background-color: #fcf82d"></td>';
                break;
            case 'REJECTED':
                print '<td title="rejected" style="width: 50px; background-color: #f40404"></td>';
                break;
            default:
                print '<td title="N/A" style="width: 50px; background-color: #f7f7f7"></td>';
                break;
          }
        }
      }
      print '</tr></table>';
      break;
    default:
      print 'no function defined for ' . $menu_type;
      break;
  }
  display_footer();
}

renderForm($menu_type_x);

?>
