<?php

include '_db.php';
include '_common.php';

if (session_status() !== PHP_SESSION_ACTIVE) {
  session_start();
}

$request_id              = get_dataowner_sequence();
$requestor_uid           = trim($_POST["sunetid"]);
$requestor_name          = trim($_POST["fullname"]);
$contact_email           = trim($_POST["contact_email"]);
$request_type            = trim($_POST["request_type"]);
$kerb_principal          = trim($_POST["kerb_principal"]);
$saml_principal          = trim($_POST["saml_principal"]);
$application_description = trim($_POST["application_description"]);
$comments                = trim($_POST["comments"]);
$requested_date          = $_POST["requested_date"];

if (!$request_type) {
  $_SESSION["message"] = 'Missing "Type of Request"';
  header('Location: ' . $_SERVER['HTTP_REFERER']);
  exit;
}

if (!$contact_email) {
  $_SESSION["message"] = 'Missing "Contact Email"';
  header('Location: ' . $_SERVER['HTTP_REFERER']);
  exit;
}

if (preg_match('/KPRINCIPAL/', $request_type)) {
   if (empty($kerb_principal)) {
     $_SESSION["message"] = 'Missing "Kerberos Principal"';
     header('Location: ' . $_SERVER['HTTP_REFERER']);
     exit;
   } else {
    $access_principal = $kerb_principal;
   }
} else {
   if (empty($saml_principal)) {
     $_SESSION["message"] = 'Missing "Entity ID"';
     header('Location: ' . $_SERVER['HTTP_REFERER']);
     exit;
   } else {
    $access_principal = $saml_principal;
   }
}

$insRec = Array(
  $request_id,
  $requestor_uid,
  $requestor_name,
  $request_type,
  $access_principal,
  $application_description,
  $comments,
  $requested_date);

$attrArray = Array();
$attribute_type = "ATTRIBUTE";

if (isset($_POST["attributes"])) {
  foreach ($_POST['attributes'] as $item) {
    array_push($attrArray,  $item);
  }
} else {
  $attribute_type = "BUNDLE";
  if (isset($_POST["attribute_bundle"])) {
    array_push($attrArray, $_POST["attribute_bundle"]);
  } else {
    $_SESSION["message"] = 'Attribute Bundle or individual Attributes must be selected';
    header('Location: ' . $_SERVER['HTTP_REFERER']);
    exit;
  }
}

insert_dataowner_request($insRec, $attribute_type, $attrArray);

?>
