<?php

include '_uit_head.php';
include '_common.php';
include '_db.php';

if (session_status() !== PHP_SESSION_ACTIVE) {
  session_start();
}

function render_form() {

  display_header('Stanford Directory Access Request');

  nav("dataowner_users");

  if (isset($_SESSION["message"])) {
    $message = $_SESSION["message"];
    if ($_SESSION["message_type"] == "DANGER") {
      print '<div class="alert alert-danger"><strong>' . $message . '</strong></div>';
    } else {
      print '<div class="alert alert-success"><strong>' . $message . '</strong></div>';
    }
    unset($_SESSION["message"]);
    unset($_SESSION["message_type"]);
  }

  print '
<script type="text/javascript" src="https://code.jquery.com/jquery-1.12.4.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/fixedcolumns/3.2.4/js/dataTables.fixedColumns.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/responsive/2.2.1/js/dataTables.responsive.min.js"></script>

<link type="text/css" rel="stylesheet" href="https://cdn.datatables.net/1.10.16/css/jquery.dataTables.min.css"/>
<link type="text/css" rel="stylesheet" href="https://cdn.datatables.net/responsive/2.2.1/css/responsive.bootstrap.min.css"/>

<style>
  .dataTables_filter { text-align: right !important; padding-bottom: 10px; }
  .dataTables_length select { width: 80px; padding-bottom: 10px; }
  div.dataTables_length label { width: 200px; float: left; text-align: left; }
  div.dataTables_info { padding-top: 10px; }
  div.dataTables_paginate { float: right; margin: 0; }
  div.content-wrapper.content-wrapper { width: 100%; }
  table.dataTable tbody td { vertical-align: top !important; }
  div#content.mc-content.span8 { width: 94%; }
}
</style>

<script type="text/javascript">
$(document).ready(function() {
  $(\'#users\').DataTable({
    pagingType: "full_numbers",
    fixedColumns: false,
    columnDefs: [ { width: 40, targets: 0 } ],
    scrollX: true,
    "fnDrawCallback": function(oSettings) {
      $(\'.dataTables_filter\').each(function () {
      });
    }
  });
});

function maintain_user(u) {
   var form = document.createElement(\'form\');
   form.action = "maintain_user.php";
   form.method = \'POST\';

   var input = document.createElement(\'input\');
   input.type = \'hidden\';
   input.name = \'username\';
   input.value = u;
   form.appendChild(input);
   document.body.appendChild(form);
   form.submit();
}

</script>';

  $users = get_users();

  if (count($users) == 0) {
    print "No records available";
    return;
  }
  //
  // bootstrap datatables
  //
  print '
    <table id="users" class="table table-bordered compact" cellspacing="0" width="100%">
      <thead>
        <tr>
          <th>SunetID</th>
          <th>Name</th>
          <th>Title</th>
          <th>Email</th>
          <th>Role</th>
          <th>Status</th>
        </tr>
      </thead>
      <tbody>';

  foreach ($users as $values) {

    if (preg_match('/INACTIVE/i', $values["status"])) {
      $row_style = 'background-color: #ffe6e6;';
    } else {
      $row_style = 'background-color: white;';
    }

    print "<tr style=\"$row_style\">";
    print '<td><a href="javascript:maintain_user(\'' . $values["uid"] . '\');"> ' . $values["uid"] . '</a></td>';
    print '<td>' . $values["full_name"] . '</td>';
    print '<td>' . shorten_string($values["title"], 35) . '</td>';
    print '<td>' . $values["email"] . '</td>';
    print '<td>' . $values["role"] . '</td>';
    print '<td>' . $values["status"] . '</td>';
    print '</tr>';
  }

  print '
      </tbody>
    </table>';

  display_footer();
}

render_form();
