<?php

include '_uit_head.php';
include '_common.php';
include '_db.php';

function render_form() {

  display_header('Stanford Directory Access Impement Request');

  $tab = 'dataowner_list_requests';
  if (isset($_GET["status"])) {
    $_SESSION["status"] = $_GET["status"];
    $tab = 'dataowner_' . $_GET["status"] . '_requests';
  } else {
    $_SESSION["status"] = '';
  }

  nav($tab);

  if (isset($_SESSION["message"])) {
    $message = $_SESSION["message"];
    if (!isset($_SESSION['message_type'])) {
      ///If not isset -> set with dumy value
      $_SESSION['message_type'] = "";
    }
    if ($_SESSION["message_type"] == "DANGER") {
      print '<div class="alert alert-danger"><strong>' . $message . '</strong></div>';
    } else {
      print '<div class="alert alert-success"><strong>' . $message . '</strong></div>';
    }
    unset($_SESSION["message"]);
    unset($_SESSION["message_type"]);
  }

  print '
<script type="text/javascript" src="https://code.jquery.com/jquery-1.12.4.js"></script>
<script type="text/javascript" src="javascript/bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="javascript/jquery-datatables/jquery.dataTables.min.js"></script>
<script type="text/javascript" src="javascript/jquery-datatables-extensions/FixedColumns/js/dataTables.fixedColumns.min.js"></script>
<script type="text/javascript" src="javascript/jquery-datatables-extensions/Responsive/js/dataTables.responsive.min.js"></script>

<link type="text/css" rel="stylesheet" href="javascript/jquery-datatables/css/jquery.dataTables.min.css"/>
<link type="text/css" rel="stylesheet" href="javascript/jquery-datatables-extensions/Responsive/css/responsive.bootstrap.min.css"/>

<style>
  .dataTables_filter { text-align: right !important; }
  .dataTables_length select { width: 80px; }
  div.dataTables_length label { width: 200px; float: left; text-align: left; padding-bottom: 10px; }
  div.dataTables_info { padding-top: 10px; }
  div.dataTables_paginate { float: right; margin: 0; }
  div.content-wrapper.content-wrapper { width: 100%; }
  table.dataTable tbody td { vertical-align: top !important; }
  div#content.mc-content.span8 { width: 96%; }
  div.modal-header { width: 886px; }
  div.modal-body { width: 850px; }
  div.modal-footer { width: 886px; }
  div.modal-content { width: 890px; }
  .row_updated { background-color: #b6b1a9 !important; }
</style>

<script type="text/javascript">
$(document).ready(function() {
    var t = $(\'#requests\').DataTable({
    pagingType: "full_numbers",
    fixedColumns: true,
    columnDefs: [ { width: 40, targets: 0 } ],
    "aoColumnDefs": [ { "sType": "html-num", "aTargets": [ 0 ] } ],
    scrollX: true,
  });

  $(\'#modal_save\').on(\'click\', function(e) {

    var str1 = "";
    var str2 = "";
    var str3 = "";
    for (i = 0; i < 99; i++) {
      var selector1 = "#orig_vals" + i;
      var selector2 = "#new_status" + i;
      var selector3 = "#comments" + i;
      if ($(selector1).length) {
        str1 += $(selector1).val() + "^";
        str2 += $(selector2).children("option:selected").val() + "^";
        str3 += $(selector3).val() + "^";
      } else {
        break;
      }
    }
    document.approver_form.f_request_id.value = $(\'#request_id\').val();
    document.approver_form.f_orig_vals.value = str1;
    document.approver_form.f_new_status.value = str2;
    document.approver_form.f_comments.value = str3;
    document.approver_form.submit();
  });
});

function request_details(id) {
  $.ajax({
    type: \'post\',
    url: \'_dataowner_list_details.php\',
    data: \'param=\' + id,
    success: function(d) {
      $(\'.modal-body\').html(d);
      $(\'.modal-body\').scrollTop(0);
      $(\'.modal-title\').html("Implementation Details for Request " + id);
    }
  });
  $(\'#detailModal\').modal();
}

function request_attributes(group_name) {
  $.ajax({
    type: \'post\',
    url: \'_dataowner_list_attributes.php\',
    data: \'param=\' + group_name,
    success: function(d) {
      $(\'.modal-body\').html(d);
      $(\'.modal-body\').scrollTop(0);
      $(\'.modal-title\').html("Attributes for " + group_name);
    }
  });
  $(\'#detailModal\').modal();
}

function request_history(id) {
  $.ajax({
    type: \'post\',
    url: \'_dataowner_list_history.php\',
    data: \'param=\' + id,
    success: function(d) {
      $(\'.modal-body\').html(d);
      $(\'.modal-body\').scrollTop(0);
    }
  });
  $(\'#detailModal\').modal();
}
</script>';

  $id = 0;
  if (isset($_GET["request_id"])) {
    $id = $_GET["request_id"];
  }
  $requests = get_requests($id);
  unset($_SESSION["status"]);

  if (count($requests) == 0) {
    print "No records available";
    return;
  }

  if ($id > 0) {
    print '<div class="alert alert-success"><strong>Request ID ' . $id . ' Created</strong></div>';
  }

  $ct = count($requests);
  $ct += 1;

  print "\n" . '<script>' . "\n";
  print 'var request_id = [];' . "\n";
  print 'var request_status = [];' . "\n";
  print 'var request_state = [];' . "\n";
  print 'var new_request_status = [];' . "\n";
  print 'var new_request_state = [];' . "\n";

  if(is_array($requests)){
    foreach ($requests as $values) {
      print 'request_id.push("' . $values["request_id"] . '");' . "\n";
      print 'request_status.push("' . $values["status"] . '");' . "\n";
      print 'request_state.push("' . $values["implementation_status"] . '");' . "\n";
      print 'new_request_status.push("' . $values["status"] . '");' . "\n";
      print 'new_request_state.push("' . $values["implementation_status"] . '");' . "\n";
    }
  }

  print '
function update_page()
{
  var ct = ' . count($requests) . ';
  var submit_string = "";
  for (i = 0; i < ct; i++) {
    if (request_status[i] != new_request_status[i]) {
      submit_string += request_id[i] + ":STATUS:" + new_request_status[i] + "^";
    }
    if (request_state[i] != new_request_state[i]) {
      submit_string += request_id[i] + ":STATE:" + new_request_state[i] + "^";
    }
  }
  submitForm.submit_string.value = submit_string;
  submitForm.submit();
}

function implementation_status_change(val, idx)
{
  //
  // alert(idx + " " + val.value + " " + request_id[idx] + " " + request_status[idx] + " " + request_state[idx]);
  //
  new_request_state[idx] = val.value;
  str_idx = "cell_i" + idx.toString();
  if (request_state[idx] == val.value) {
    $("#" + str_idx).removeClass("row_updated");
  } else {
    $("#" + str_idx).addClass("row_updated");
  }
}

function status_change(val, idx)
{
  //
  // alert(val.value + " " + request_id[idx] + " " + request_status[idx] + " " + request_state[idx]);
  //
  new_request_status[idx] = val.value;
  str_idx = "cell_s" + idx.toString();
  if (request_status[idx] == val.value) {
    $("#" + str_idx).removeClass("row_updated");
  } else {
    $("#" + str_idx).addClass("row_updated");
  }
}
</script>';

  //
  // bootstrap datatables
  //
  print '
    <form id="submitForm" name="submitForm" method="post" action="_dataowner_implement_request_x.php">
      <input type="hidden" name="submit_string" id="submit_string" value="">
    </form>';

  print '
    <form id="approver_form" name="approver_form" method="post" action="_approver_update_x.php">
      <input type="hidden" id="f_request_id" name="f_request_id" value="">
      <input type="hidden" id="f_orig_vals" name="f_orig_vals" value="">
      <input type="hidden" id="f_new_status" name="f_new_status" value="">
      <input type="hidden" id="f_comments" name="f_comments" value="">
    </form>

    <div id="detailModal" class="modal fade" role="dialog"  style="width:940px; margin-left: -500px;">
     <div class="modal-dialog" style="width:940px;">
        <div class="modal-content">
          <div class="modal-header">
           <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <h3 class="modal-title" style="color: #0275d8;">Implementation Details</h3>
          </div>
          <div class="modal-body">
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            <button type="button" class="btn btn-default" id="modal_save" name="modal_save" data-dismiss="modal">Save</button>
          </div>
        </div>
      </div>
    </div>

<!--
    <table border="0" class="noclass" cellspacing="0" cellpadding="0" width="100%">
    <tr>
      <td style="border: none;" width="500px">
      <td>
      <td style="border: none;">
        <button type="button" id="submit_button1" class="btn btn-primary">Update</button>
      </td>
      <td style="border: none;">
        <button type="button" id="submit_button1" class="btn btn-primary">Cancel</button>
      </td>
    </tr>
    <tr height="10px">
      <td style="border: none;">
      </td>
      <td style="border: none;">
      </td>
    </tr>
    </table>
-->

    <table id="requests" class="table table-striped table-bordered compact" cellspacing="0" width="100%">
      <thead>
        <tr>
          <th>ID</th>
          <th>Requestor</th>
          <th>Requested</th>
          <th>Approval Status</th>
          <th>Implementation State</th>
        </tr>
      </thead>
      <tbody>';

  $arr_ct = 0;
  if(is_array($requests)){
    foreach ($requests as $values) {
      print '<tr>';
      print '<td>
       <a href="javascript:request_details(\'' . $values["request_id"] . '\');"> ' . $values["request_id"] . '</a></td>';
      print '<td>' . $values["requestor_name"] . '</td>';
      $date = new DateTime($values["requested_date"]);
      print '<td>' . date_format($date, "m/d/Y") . '</td>';

      print '<td data-search="' . $values["status"] . '" id=\'cell_s' . $arr_ct . '\'>
        <select data-size="auto" id="status' . $values["request_id"] . '" name="status' . $values["request_id"] . '" onchange="status_change(this, ' . $arr_ct . ');">';

      $s_pending = "";
      $s_submitted = "";
      $s_approved = "";
      $s_rejected = "";
      $s_waiting = "";
      switch ($values["status"]) {
        case "PENDING":
          $s_pending = "selected";
          break;
        case "SUBMITTED":
          $s_submitted = "selected";
          break;
        case "APPROVED":
          $s_approved = "selected";
          break;
        case "REJECTED":
          $s_rejected = "selected";
          break;
        case "WAITING":
          $s_waiting = "selected";
          break;
      }

      print '<option ' . $s_pending . '>PENDING</option>';
      print '<option ' . $s_submitted . '>SUBMITTED</option>';
      print '<option ' . $s_approved . '>APPROVED</option>';
      print '<option ' . $s_rejected . '>REJECTED</option>';
      print '<option ' . $s_waiting . '>WAITING</option>';
      print '</select></td>';

      print '<td data-search="' . $values["implementation_status"] . '" id=\'cell_i' . $arr_ct . '\'>
        <select data-size="auto" id="implementation_status_' . $values["request_id"] . '" name="implementation_status_' . $values["request_id"] . '" onchange="implementation_status_change(this, ' . $arr_ct . ')";>';

      $pending = "";
      $implemented = "";
      $abandoned = "";
      switch ($values["implementation_status"]) {
        case "PENDING":
          $pending = "selected";
          break;
        case "IMPLEMENTED":
          $implemented = "selected";
          break;
        case "ABANDONED":
          $abandoned = "selected";
          break;
      }

      print '<option ' . $pending . '>PENDING</option>';
      print '<option ' . $implemented . '>IMPLEMENTED</option>';
      print '<option ' . $abandoned . '>ABANDONED</option>';
      print '</select></td>';

      print '</tr>';
      $arr_ct += 1;
    }
  }

  print '
      </tbody>
    </table>';

  display_footer();
}

render_form();
