<?php

include '_uit_head.php';
include '_db.php';
include '_common.php';

if (session_status() !== PHP_SESSION_ACTIVE) {
  session_start();
}

function render_form() {

  if (!isset($_SERVER['REMOTE_USER'])) {
    return;
  }

  $x = get_sunet_details();
  $vars = explode("^", $x);
  $su_fullname = $vars[0];
  $su_email    = $vars[1];
  $su_org      = $vars[2];

  display_header('Stanford Directory Access Request');
  nav("dataowner_request");

  if (isset($_SESSION["message"])) {
    $message = $_SESSION["message"];
    print '<div class="alert alert-danger"><strong>' . $message . '</strong></div>';
    unset($_SESSION["message"]);
  }

print '
<script type="text/javascript">
$(document).ready(function() {
  $.fn.selectpicker.Constructor.DEFAULTS.styleBase = \'form-control\';
  $.fn.selectpicker.Constructor.DEFAULTS.style = \'\';
  $("#view_button_bundle").hide();
  $("#view_button_selected").hide();

  var rows = $(\'table.main tr\');
  var shib_rows = rows.filter(\'.shib_rows\');
  var kerb_rows = rows.filter(\'.kerb_rows\');
  shib_rows.hide();
  kerb_rows.hide();
  var attr_bundle_name = "";

  $(\'.selectpicker\').on("change", function(){
    var id = $(this).attr("id");
    var selected = $(this).find("option:selected").val();
    if (id == "request_type") {
      if (selected == "ENTITYID") {
        kerb_rows.hide();
        shib_rows.show();
      } else {
        shib_rows.hide();
        kerb_rows.show();
      }
    } else if (id == "attribute_bundle") {
      $("#attributes").val(\'default\');
      $("#attributes").selectpicker("refresh");
      $("#view_button_bundle").show();
      $("#view_button_selected").hide();
      attr_bundle_name = selected;
    } else if (id == "attributes") {
      $("#attribute_bundle").val(\'default\');
      $("#attribute_bundle").selectpicker("refresh");
      $("#view_button_bundle").hide();
      $("#view_button_selected").show();
      attr_bundle_name = "";
    }
  });
  $(\'#view_button_bundle\').on(\'click\', function(e) {
    $(\'.modal-title\').html("Attributes for " + attr_bundle_name);
    view_attributes(attr_bundle_name);
  });
  $(\'#view_button_selected\').on(\'click\', function(e) {
    var str = "";
    $(\'.modal-title\').html("Selected Attributes");
    var select1 = document.getElementById("attributes");
    for (i = 0; i < select1.length; i++) {
      if (select1.options[i].selected == true) {
        str += select1.options[i].value + "<br>";
      }
    }
    $(\'.modal-body\').html(str);
    $(\'.modal-body\').scrollTop(0);
    $(\'#detailModal\').modal();
  });
});

function view_attributes(group_name) {
  $.ajax({
    type: \'post\',
    url: \'_dataowner_list_attributes.php\',
    data: \'param=\' + group_name,
    success: function(d) {
      $(\'.modal-body\').html(d);
      $(\'.modal-body\').scrollTop(0);
    }
  });
  $(\'#detailModal\').modal();
}

</script>';

  $contact_email_info = "Supply a group e-mail contact (e.g., mygroup@lists.stanford.edu)";

  print '
<style>
  .text-muted:hover, .text-muted:focus { color: #f4f142; }
  div.content-wrapper.content-wrapper { width: 100%; }
  table.dataTable tbody td { vertical-align: top !important; }
  div#content.mc-content.span8 { width: 96%; }
  div.modal-header { width: 886px; }
  div.modal-body { width: 850px; }
  div.modal-footer { width: 886px; }
  div.modal-content { width: 890px; }
}
</style>';

  print '
    <div id="detailModal" class="modal fade" role="dialog"  style="width:940px; margin-left: -500px;">
     <div class="modal-dialog" style="width:940px;">
        <div class="modal-content">
          <div class="modal-header">
           <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <h3 class="modal-title" style="color: #8c1515">Attributes</h3>
          </div>
          <div class="modal-body">
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>';

  print '
  <form name="dataowner_request" id="dataowner_request" method="post" action="_dataowner_requests_x.php">
    <input type="hidden" name="sunetid" value="' . $_SERVER['REMOTE_USER'] . '">
    <input type="hidden" name="fullname" value="' . $su_fullname . '">
    <input type="hidden" name="email" value="' . $su_email . '">
    <input type="hidden" name="requested_date" value="' . date('Y-m-d 00:00:00') . '">

    <table border=1 class="main">
      <tr>
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b>SunetID</b>
        </td>
        <td>' . $_SERVER['REMOTE_USER'] . '</td>
      </tr>

      <tr>
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b>Name</b>
        </td>
        <td>' . $su_fullname . '</td>
      </tr>

      <tr>
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b title="' . $contact_email_info . '">Contact E-mail</b>
        </td>
        <td><input type="email" name="contact_email" id="contact_email" style="height: 30px; width:100%;" value="'. $su_email . '"></td>
      </tr>

      <tr>
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b>Date Requested</b>
        </td>
        <td>' . date('m/d/Y') . '</td>
      </tr>

      <tr>
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b>Type of Request</b>
        </td>
        <td>
          <select class="selectpicker" data-size="auto" id="request_type" name="request_type" title="Select Request Type">
            <option value="KPRINCIPAL">OpenLDAP Access (principal)</option>
            <option value="ENTITYID">SAML Attribute Release (entityID)</option>
          </select>
        </td>
      </tr>

      <tr class="kerb_rows">
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b>Kerberos Principal</b>
        </td>
        <td><input type="text" name="kerb_principal" id="principal" style="height: 30px; width:100%;"></td>
      </tr>

      <tr class="shib_rows">
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b>Entity ID</b>
        </td>
        <td><input type="text" name="saml_principal" id="principal" placeholder="https://" style="height: 30px; width:100%;"></td>
      </tr>

      <tr class="all_rows">
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b>Attribute Bundle</b>
        </td>
        <td>
          <select class="selectpicker" data-size="auto" id="attribute_bundle" name="attribute_bundle">';

  $bundle_array = get_bundle();
  print '<option disabled selected>Nothing selected</option>';
  foreach ($bundle_array as $value) {
    // Skip 'All'
    if ($value['group_name'] != 'All') {
      print '<option>' . $value['group_name'] . '</option>';
    }
  }
  print '
          </select>
         <button type="button" class="btn btn-default" id="view_button_bundle" name="view_button_bundle" data-dismiss="modal">View Attributes</button>
        </td>
      </tr>

      <tr class="all_rows">
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;" nowrap>
          <b>Custom Attributes</b>
        </td>
        <td>
          <select class="selectpicker" multiple id="attributes" name="attributes[]">';
  $attribute_array = get_attributes();
  foreach ($attribute_array as $value) {
    print '<option>' . $value['attribute_name'] . '</option>';
  }
  print '
          </select>
         <button type="button" class="btn btn-default" id="view_button_selected" name="view_button_selected" data-dismiss="modal">View Selected</button>
        </td>
      </tr>

      <tr class="all_rows">
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;">
          <b>Application Description</b>
        </td>

        <td style="width: 400px; border-bottom: 0px;" nowrap>
          <textarea class="form-control" id="application_description" name="application_description" rows="6" style="width:98%;"></textarea>
        </td>
      </tr>

      <tr class="all_rows">
        <td style="width: 200px; vertical-align:top; border-bottom: 0px; background-color: #f2f1eb;">
          <b>Comments</b> (please make request for any<br>additional attribute(s) not listed here)
        </td>

        <td style="width: 400px; border-bottom: 0px;" nowrap>
          <textarea class="form-control" id="comments" name="comments" rows="6" style="width:98%;"></textarea>
        </td>
      </tr>
    </table>
    <div style="padding-top: 20px;"><button type="submit" class="btn btn-primary">Submit</button></div>
  </form>';

  display_footer();
}

render_form();

?>
