--
-- Table structure for table `dataowner_approval`
--

DROP TABLE IF EXISTS `dataowner_approval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_approval` (
  `request_id` int(11) NOT NULL,
  `approver_uid` varchar(32) NOT NULL,
  `approver_name` varchar(64) NOT NULL,
  `approver_title` varchar(64) NOT NULL,
  `role` enum('APPROVE','AUDIT') NOT NULL DEFAULT 'APPROVE',
  `status` enum('PENDING','APPROVED','REJECTED','WAITING') NOT NULL DEFAULT 'PENDING',
  `email_status` enum('PENDING','SENT','RESEND') NOT NULL DEFAULT 'PENDING',
  `comment` text,
  `date_last_maint` datetime NOT NULL,
  `date_added` datetime NOT NULL,
  PRIMARY KEY (`request_id`,`approver_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataowner_attribute_groups`
--

DROP TABLE IF EXISTS `dataowner_attribute_groups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_attribute_groups` (
  `group_name` varchar(512) DEFAULT NULL,
  `created_by_uid` varchar(32) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataowner_attributes`
--

DROP TABLE IF EXISTS `dataowner_attributes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_attributes` (
  `attribute_name` varchar(512) DEFAULT NULL,
  `group_name` varchar(512) DEFAULT NULL,
  `created_by_uid` varchar(32) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `dataowner_log`
--

DROP TABLE IF EXISTS `dataowner_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_log` (
  `record_id` int(11) NOT NULL,
  `update_id` varchar(16) NOT NULL,
  `action` varchar(16) NOT NULL,
  `table_name` varchar(64) DEFAULT NULL,
  `key_fields` varchar(255) DEFAULT NULL,
  `key_values` varchar(255) DEFAULT NULL,
  `field_name` varchar(64) DEFAULT NULL,
  `old_value` varchar(255) DEFAULT NULL,
  `new_value` varchar(255) DEFAULT NULL,
  `uid` varchar(64) DEFAULT NULL,
  `date_added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`record_id`),
  KEY `idx_date` (`date_added`),
  KEY `idx_update_id` (`update_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataowner_request`
--

DROP TABLE IF EXISTS `dataowner_request`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_request` (
  `request_id` int(11) NOT NULL,
  `requestor_uid` varchar(32) NOT NULL,
  `requestor_name` varchar(64) DEFAULT NULL,
  `contact_email` varchar(128) DEFAULT NULL,
  `request_type` enum('ENTITYID','KPRINCIPAL') DEFAULT NULL,
  `access_principal` text,
  `application_description` text NOT NULL,
  `comment` text,
  `requested_date` datetime NOT NULL,
  `status` enum('PENDING','READY','SUBMITTED','APPROVED','REJECTED','WAITING','DELETED') DEFAULT NULL,
  `implementation_status` enum('PENDING','IMPLEMENTED','ABANDONED') NOT NULL,
  `date_last_maint` datetime NOT NULL,
  `date_added` datetime NOT NULL,
  PRIMARY KEY (`request_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataowner_request_archive`
--

DROP TABLE IF EXISTS `dataowner_request_archive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_request_archive` (
  `request_id` int(11) NOT NULL,
  `requestor_uid` varchar(32) NOT NULL,
  `requestor_name` varchar(64) DEFAULT NULL,
  `access_principal` text,
  `application_description` text NOT NULL,
  `comment` text,
  `requested_date` datetime NOT NULL,
  `status` enum('PENDING','READY','SUBMITTED','APPROVED','REJECTED','WAITING') NOT NULL DEFAULT 'PENDING',
  `implementation_status` enum('PENDING','IMPLEMENTED') NOT NULL,
  `date_last_maint` datetime NOT NULL,
  `date_added` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataowner_request_attr`
--

DROP TABLE IF EXISTS `dataowner_request_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_request_attr` (
  `request_id` int(11) NOT NULL,
  `attribute` varchar(32) NOT NULL,
  `attribute_type` enum('ATTRIBUTE','BUNDLE') NOT NULL DEFAULT 'ATTRIBUTE',
  `date_last_maint` datetime NOT NULL,
  `date_added` datetime NOT NULL,
  PRIMARY KEY (`request_id`,`attribute`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataowner_request_attr_archive`
--

DROP TABLE IF EXISTS `dataowner_request_attr_archive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_request_attr_archive` (
  `request_id` int(11) NOT NULL,
  `attribute` varchar(32) NOT NULL,
  `attribute_type` enum('ATTRIBUTE','BUNDLE') NOT NULL DEFAULT 'ATTRIBUTE',
  `date_last_maint` datetime NOT NULL,
  `date_added` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataowner_reviewer`
--

DROP TABLE IF EXISTS `dataowner_reviewer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dataowner_reviewer` (
  `uid` varchar(32) NOT NULL,
  `full_name` varchar(64) NOT NULL,
  `title` varchar(64) NOT NULL,
  `email` varchar(255) NOT NULL,
  `role` enum('ADMINISTRATOR','APPROVE','AUDIT') NOT NULL DEFAULT 'AUDIT',
  `status` enum('ACTIVE','INACTIVE') NOT NULL DEFAULT 'ACTIVE',
  `date_last_maint` datetime NOT NULL,
  `date_added` datetime NOT NULL,
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

-- Add some data
LOCK TABLES `dataowner_reviewer` WRITE;
/*!40000 ALTER TABLE `dataowner_reviewer` DISABLE KEYS */;
INSERT INTO `dataowner_reviewer` VALUES ('csr','Carolyn S Ratcliff','Computing Info Systems Analyst','cratcliff@stanford.edu','APPROVE','ACTIVE','2018-02-02 16:53:12','2011-06-20 13:21:49'),('tblack','Tom Black','Associate Vice Provost for Student Affairs and University Regist','tblack@stanford.edu','APPROVE','INACTIVE','2019-12-03 11:29:51','2011-06-20 13:22:31'),('piersonm','Megan Pierson','Associate Provost for Faculty Affairss','piersonm@stanford.edu','APPROVE','INACTIVE','2019-12-03 11:29:26','2011-06-20 13:22:52'),('khcl','Karen Lawrence','Compensation Manager','khcl@SLAC.Stanford.EDU','APPROVE','INACTIVE','2019-12-03 11:28:26','2011-06-20 13:23:31'),('davida19','David Aitchison','HUMAN RESOURCES MANAGEMENT-SHC','daitchison@stanfordmed.org','APPROVE','INACTIVE','2019-12-03 11:29:02','2011-06-21 00:22:29'),('whm','Bill MacAllister','System Software Developer','whm@stanford.edu','AUDIT','INACTIVE','2015-03-16 16:19:47','2011-06-21 00:23:35'),('lpauga','Luisa Pauga','Internal Auditor','lpauga@stanford.edu','AUDIT','INACTIVE','2014-04-22 13:47:59','2011-07-01 16:34:38'),('ericn','Mr Eric Nakagawa','Senior Manager','eric.nakagawa@stanford.edu','AUDIT','INACTIVE','2014-04-22 13:48:43','2011-07-01 16:35:29'),('saracook','Sara Cook','Developer','saracook@stanford.edu','APPROVE','INACTIVE','2019-11-12 08:30:55','2015-03-16 16:21:12'),('cransom','Claudia Ransom','Lead Records Specialist','claudia@SLAC.Stanford.EDU','APPROVE','ACTIVE','2019-12-03 11:25:25','2011-08-30 14:55:03'),('cfrattin','Carol Frattinii','Sr. HR Information Systems Specialist','adamhl@stanford.edu','APPROVE','INACTIVE','2019-12-04 08:58:40','2011-11-18 12:36:26'),('ldixon','Lynn Dixon','Computing Info System Analyst (Faculty Affairs)','ldixon@stanford.edu','APPROVE','ACTIVE','2018-02-02 16:53:47','2012-01-23 09:57:24'),('cheroux','Chris Heroux\r\n','Administrative Systems','adamhl@stanford.edu','ADMINISTRATOR','ACTIVE','2019-08-16 15:57:12','2018-02-02 13:48:01'),('adamhl','Adam Henry Lewenberg\r\n','Computing Servicess','adamhl@stanford.edu','ADMINISTRATOR','ACTIVE','2019-08-16 15:56:57','2018-02-05 13:25:46'),('toaivo','Toai Vo\r\n','Administrative Systems','toaivo@stanford.edu','AUDIT','ACTIVE','2019-11-22 08:11:30','2018-02-03 10:20:03'),('ljlgeek','L J Laubenheimer\r\n','Computing Services\r\n','ljlgeek@stanford.edu\r\n','ADMINISTRATOR','ACTIVE','2019-08-15 10:06:01','2018-02-03 10:23:46'),('vivienwu','Vivien Wu\r\n','Computing Services','vivienwu@stanford.edu','AUDIT','ACTIVE','2019-11-25 13:04:33','2018-02-05 13:26:02'),('psr123','Srinivas Rao Puttagunta','Administrative Systems','psr123@stanford.edu','ADMINISTRATOR','ACTIVE','2019-12-10 14:14:25','2018-02-05 13:29:16'),('psr12345','--','Mr.','psr123@stanford.edu','APPROVE','INACTIVE','2019-11-14 09:12:30','2019-08-16 10:48:37'),('sknoduru','--','--','--','ADMINISTRATOR','ACTIVE','2019-08-16 13:16:20','2019-08-16 13:16:20'),('psr123123','--','--','--','ADMINISTRATOR','INACTIVE','2019-11-25 12:41:56','2019-08-16 13:25:35'),('lbregan','Linda B. Regan','Director of Student Information Systems','lbregan@stanford.edu','APPROVE','ACTIVE','2019-12-04 10:09:38','2019-12-03 11:27:05'),('martincy','Cindy L. Martin','Senior Director, Client Services','martincy@stanford.edu','APPROVE','ACTIVE','2019-12-04 10:10:10','2019-12-03 11:31:40');
/*!40000 ALTER TABLE `dataowner_reviewer` ENABLE KEYS */;
DELETE FROM dataowner_reviewer WHERE uid='psr123123';
DELETE FROM dataowner_reviewer WHERE uid='psr12345';
DELETE FROM dataowner_reviewer WHERE uid='saracook';
DELETE FROM dataowner_reviewer WHERE uid='sknoduru';
UNLOCK TABLES;


-- Setup the nextval function.

DROP FUNCTION IF EXISTS `nextval`;

DELIMITER ;;
CREATE FUNCTION `nextval`(seq_name varchar(100)) RETURNS bigint(20)
BEGIN
    DECLARE cur_val bigint;

    SELECT
        cur_value INTO cur_val
    FROM
        sequences
    WHERE
        name = seq_name;

    IF cur_val IS NOT NULL THEN
        UPDATE
            sequences
        SET
            cur_value = IF (
                (cur_value + increment) > max_value OR (cur_value + increment) < min_value,
                IF (
                    cycle = TRUE,
                    IF (
                        (cur_value + increment) > max_value,
                        min_value,
                        max_value
                    ),
                    NULL
                ),
                cur_value + increment
            )
        WHERE
            name = seq_name;
    END IF;
    RETURN cur_val;
END ;;
DELIMITER ;

